###################################################
#
# $Id$
#
# GE - game environment
# settings for MUD-clients JMC & mmc
#
#   (c) Andrew I. Baznikin (dikiy@mud.ru) 2001, 2002
#   
###################################################

package ge::PK;
require MUD;
use locale;

#      
$TRACK_HIGHLIGHT="O";
#      
$TRACK_SHOW_PRIORITY=0;

#   
$TRACK_INCOME_PRIORITY=1;
#   
$TRACK_OUTCOME_PRIORITY=10;

$track_dirs_pattern = "- PATHRATE   DIRECTION";

#  -     
@track_path;

$hunt_target;

@pathrate = (
	{ t => " ",			p => 7 },
	{ t => "",			p => 6 },
	{ t => "  ",	p => 5 },
	{ t => "  ", p => 4 },
	{ t => "  ",	p => 3 },
	{ t => "  ",	p => 2 },
	{ t => " ",			p => 1 }
);

@directions = (
	{ t => " ",	p => $TRACK_OUTCOME_PRIORITY },
	{ t => " ",		p => $TRACK_OUTCOME_PRIORITY },
	{ t => " ",	p => $TRACK_OUTCOME_PRIORITY },
	{ t => " ",	p => $TRACK_OUTCOME_PRIORITY },
	{ t => "",		p => $TRACK_OUTCOME_PRIORITY },
	{ t => "",		p => $TRACK_OUTCOME_PRIORITY },
	{ t => " ",	p => $TRACK_INCOME_PRIORITY },
	{ t => " ",		p => $TRACK_INCOME_PRIORITY },
	{ t => " ",	p => $TRACK_INCOME_PRIORITY },
	{ t => " ",	p => $TRACK_INCOME_PRIORITY },
	{ t => "",	p => $TRACK_INCOME_PRIORITY },
	{ t => "",	p => $TRACK_INCOME_PRIORITY }
);

sub priority {
	my ($t, @ar)  = @_;
	foreach (@ar) {
		if ($_->{t} eq $t) {
			return $_->{p};
		}
	}
	return undef;
}

sub create_trigs {

	my $paths = "(". join ("\|", map {$_->{t}} @pathrate) . ")";
	my $dirs  = "(". join ("\|", map {$_->{t}} @directions) . ")";

	$track_dirs_pattern =~ s/PATHRATE/$paths/;
	$track_dirs_pattern =~ s/DIRECTION/$dirs/;

	MUD::add_trigger '   ', '      ',
		sub {
			P::sendl(" $hunt_target");
		},
		"1200n:PKTRACKPATH";

	MUD::add_trigger $track_dirs_pattern, undef,
		sub {
			BEGIN { undef @U::_track_path; }
			push @U::_track_path, {rate => $1, dir => $2} ;
			P::enable('PKTRACKPATH_END');
			undef $:;
		},
		"2101n:PKTRACKPATH";

	MUD::add_trigger '.*', undef,
		sub {
			my $max = 0;
			@track_path = sort {
				my $ap = priority ($a->{rate}, @pathrate) * priority ($a->{dir}, @directions);
				my $bp = priority ($b->{rate}, @pathrate) * priority ($b->{dir}, @directions);
				$bp <=> $ap;
			} @U::_track_path;
			foreach (@track_path) {
				my $pr = priority ($_->{rate},@pathrate) * priority ($_->{dir}, @directions);
				$max = ($max > $pr) ? $max : $pr;				
				P::echo " ".((priority($_->{dir}, @directions) == $TRACK_INCOME_PRIORITY)?"-> ":"<- ").(($TRACK_SHOW_PRIORITY)?"($pr) ":"")."$_->{rate} ".(($max == $pr)?"\003$TRACK_HIGHLIGHT":"")."$_->{dir}";
			}
			undef @U::_track_path;
			P::disable('PKTRACKPATH_END');
		},
		"2100n-:PKTRACKPATH,PKTRACKPATH_END";
}

#  -  "".
sub hunt {
	$_ = shift;
	my $mode = undef;
	my $e = "(?:||)";
	my $e2 = "(?:||)";
	my $moving = "$e|$e2|$e2|$e2";
	my $standing = "|||||";

	/^[+1]|([^\W0-9])+$/ && do {
		if ($1) {
			$mode = "setup";
			$hunt_target = $_;
		} else {
			$mode = "enable";
		}
		if (!defined $hunt_target) {
			P::echo "${MC::clr_b_pink}  ";
			return undef;
		}
		$U::hunt = "HUNT";
		P::msg "adding hunt triggers...";
		MUD::remove_trigger ('HUNT');
		MUD::add_trigger
			"(?i)^($hunt_target) ($moving) (.*)",
			Parser::parse_string('&N$1 &P$2 $3 !!! !!!'),
			sub {
				P::echo "TARGET $hunt_target is HERE! Atacking!";
			},
			"5000f:HUNT";
		MUD::add_trigger
			"(?i)^(.*?)($hunt_target)(,.*?)? +($standing) ",
			Parser::parse_string('&N$2 &P$4  !!!!!!'),
			sub {
				P::echo "TARGET $hunt_target is HERE! Atacking!";
			},
			"5000f:HUNT";
		};
	/^[\-0]$/ && do {
		$mode = "disable";
		$U::hunt = '';
		P::msg "removing hunt triggers...";
		MUD::remove_trigger ('HUNT');
		};
	if ( $mode eq "disable" && defined $hunt_target) {
		P::echo "${MC::clr_b_pink} $hunt_target ";
	} elsif (!defined $hunt_target) {
		P::echo "${MC::clr_b_pink}  ";
	} else {
		P::echo "${MC::clr_b_pink} : $hunt_target".(($U::hunt eq "HUNT") ? "" : " ! !");
	}
	
}

#  - "   ".
sub track_go_best {

	my @dirs;
	my $max;

	if (!defined @track_path) {
		P::echo "${MC::clr_b_white}   !";
		P::echo "";
	} else {
		foreach (@track_path) {
			my $pr = priority ($_->{rate},@pathrate) * priority ($_->{dir}, @directions);
			$max = ($max > $pr) ? $max : $pr;				
			push @dirs, $_->{dir} if ($pr == $max);
		}
		if ($#dirs == -1) {
			P::echo "${MC::clr_b_white}  !   ";
			P::echo " - \003$TRACK_HIGHLIGHT".(join " ", @dirs);
			P::echo "";
		} elsif ($#dirs == 0) {
			P::echo "   \003$TRACK_HIGHLIGHT$dirs[0]";
			P::echo "";
			s/^ // foreach @dirs;
			P::sendl $dirs[0];
		} else {
			P::echo "  !";
			s/^ // foreach @dirs;
			P::echo " - \003$TRACK_HIGHLIGHT".(join " ", @dirs);
			P::echo "";
		}
	}
}

create_trigs();

1;