###################################################
#
# $Id$
#
# GE - game environment
# settings for MUD-clients JMC & mmc
#
#   (c) Andrew I. Baznikin (dikiy@mud.ru) 2001, 2002
#   
###################################################

package ge::char;
use ge::conf;

require Exporter;

@ISA=qw(Exporter);
@EXPORT=qw(ReadChFile, ShowChSelectMenu, do_ChSelect, init);

my %Character;
my @CharData;

sub ReadChFile
{
# Function ReadChFile load characters data from file and return array of
# hashes. If recieving parameter, it will translated as filename, overwise
# filename getted from config 'CharDataFile' parameter, overwise
# from "./settings/char.dat" file.
	my @Chars;
	my %ch_hash;
	my $first = 1;

	MC::ge_print "Reading char data from ". conf(dat_prefix) ."/". conf(CharDataFile);
	my $file = shift  || conf(dat_prefix) ."/". conf(CharDataFile) || "./dat/char.dat";
	unless (open F, "<$file") {
		MC::ge_print ("${MC::clr_b_red}   ! $file");
	}

	while (<F>) {
		chomp;
		break if (( $line =~ m/^\s*$/ ) || ( $line =~ m/^[;#].*$/ ));
		my $line = $_;

		if ( $line =~ m/^\[\s*char\s*\]/i ) {
			if (!$first) {
				push @Chars, { %ch_hash };
				$str = sprintf "%-15s on %-15s:%4s (%s)", $ch_hash{name}, $ch_hash{host}, $ch_hash{port}, $ch_hash{description};
				MC::ge_print "-- $str" if conf(debug)>=2;
			}
			%ch_hash = {};
			$first = 0;
		} else {
			(my $nam, my $val) = split(/\s*=\s*/, $line);
			$ch_hash{$nam} = $val;
		}

	}
	push @Chars, { %ch_hash };

	$str = sprintf "%-15s on %-15s:%4s (%s)", $ch_hash{name}, $ch_hash{host}, $ch_hash{port}, $ch_hash{description};
	MC::ge_print "-- $str" if conf(debug)>=2;
	close F;

	return @Chars;
}

sub ShowChSelectMenu
{
	my @ch_arr = @CharData;

	MC::ge_print ("  :");
	if (!scalar(@ch_arr)) { MC::ge_print("  "); }
	foreach $i (0 .. $#ch_arr) {
		$str = sprintf "%u. %-13s| %-20s:%5s | %s", $i+1, $ch_arr[$i]{name}, $ch_arr[$i]{host}, $ch_arr[$i]{port}, $ch_arr[$i]{description};
		MC::ge_print ($str);
	}
}

sub do_ChSelect
{
	$str = shift || do {ShowChSelectMenu(); return;} ;

	%Character = {};
	$Is_Bad_Pass = 0;

	if (( $str !~ m/\d/) || ($str>$#CharData+1) || ($str<0)) {
		MC::ge_print ("  ");
		return;
	}
	%Character = %{$CharData[$str-1]};
	ge::conf::load_mud_conf($Character{mudfile});
	MC::ge_print ("${MC::clr_b_green} $Character{name}  \"". conf(MudName) ."\" ($Character{host}:$Character{port})");
	MC::ge_enable ("LOGON");
	MC::ge_log("off");
	MC::ge_connect($Character{host}, $Character{port});
}

=head1 
sub logon_sub {
	my $str = $_;
	for ($str)  {
		/$ge::conf::Conf{'LogonUserStr'}/  &&  do {
			MC::ge_print("USER_STR") if $ge::conf::Conf{debug}>=2;
			MC::ge_send ($ge::char::Character{name}); last;
		};
		/$ge::conf::Conf{'LogonPwdStr'}/  &&  do {
			MC::ge_print ("PASS_STR") if $ge::conf::Conf{debug}>=2;
			if ((!$Is_Bad_Pass) && ($ge::char::Character{password} ne "")) {
				MC::ge_send ($ge::char::Character{password}); last;
			}
			last;
		};
		/$ge::conf::Conf{'LogonFailure'}/  &&  do {
			MC::ge_print ("LOGON_FAILURE_STR") if $ge::conf::Conf{debug}>=2;
			$_ = undef;
			MC::ge_print ("${str}");
			$Is_Bad_Pass = 1;
			last;
		};
		/$ge::conf::Conf{'LogonSucces'}/  &&  do {
			MC::ge_print("LOGON_SUCCESS_STR") if $ge::conf::Conf{debug}>=2;
			($m,$y) = (localtime)[4,5]; $m++; $y += 1900;
			$now = sprintf("%02u-%02u", $m, $y);
			if ($m-1) {$m--; $y} else {$m = 12; $y--};
			$last = sprintf ("%02u-%02u", $m, $y);
			mkdir "logs", 0770;
			mkdir "logs/$ge::conf::Conf{MudName}", 0770;
			CMD::cmd_log("-c","./logs/$ge::conf::Conf{MudName}/$ge::char::Character{name}_$now.log");
			if ( -e "./logs/$ge::conf::Conf{MudName}/$Character{name}_$last.log" && $ge::conf::Conf{ArcOldLogs}) {
				MC::ge_print(" -   .");
				`rar m -ep .\\logs\\$ge::conf::Conf{MudName}\\$Character{name}_$last.rar .\\logs\\$Character{name}_$last.log`;
			}
			MC::ge_disable("LOGON");
			$U::my_name = $Character{name};
			last;
		};
	}
}

{}, '.*', "2500nf-:LOGON";
=cut

sub init {
	%Character = undef;
	@CharData = ReadChFile;
}

BEGIN {}

1
