###################################################
#
# $Id$
#
# GE - game environment
# settings for MUD-clients JMC & mmc
#
#   (c) Andrew I. Baznikin (dikiy@mud.ru) 2001, 2002
#   
###################################################

package ge::client;
use strict;
use ge::client::override;

my $client = undef;
my $ver = undef;

sub client { return $client;}
sub version { return $ver;}

eval {
	$_ = CL::get_version();
	if (/^MMC v([\d\.]+) /) {
		$client = "mmc";
		$ver = $+;
		eval "use ge::client::mmc";
	}
};


eval {
	if (defined $main::jmc->CommandChar) {
		$client = "jmc";
		$ver = "unknown";
		eval "use ge::client::jmc";
	}
};

if (defined $client) {
	MC::ge_print ("GE startup: client=$client version=$ver");
} else {
	die "Can't identify MUD client! Please report via email dikiy\@mud.ru. Thank you.";
}

1;
 