###################################################
#
# $Id$
#
# GE - game environment
# settings for MUD-clients JMC & mmc
#
#   (c) Andrew I. Baznikin (dikiy@mud.ru) 2001, 2002
#   
###################################################

package ge::client::override;
use strict;

package MC;

sub ge_print {
	print("You must override function 'ge_print' with ./ge/client/". ge::client::client() .".pm !");
	print("Arguments: ge_print STRING");
	print("  STRING - string to print");
}

sub ge_connect {
	MC::ge_print("${MC::clr_b_red}You must override function 'ge_connect' with ./ge/client/". ge::client::client() .".pm !");
	MC::ge_print("${MC::clr_red}Arguments: ge_connect HOST PORT");
	MC::ge_print("${MC::clr_red}  HOST - host to connect");
	MC::ge_print("${MC::clr_red}  PORT - port to connect");
}

sub ge_log {
	MC::ge_print("${MC::clr_b_red}You must override function 'ge_log' with ./ge/client/". ge::client::client() .".pm !");
	MC::ge_print("${MC::clr_red}Arguments: ge_log FILENAME OR ge_log off");
	MC::ge_print("${MC::clr_red}  FILENAME - file to write log in");
	MC::ge_print("${MC::clr_red}  off - turn logging off");
}

sub ge_enable {
	MC::ge_print("${MC::clr_b_red}You must override function 'ge_enable' with ./ge/client/". ge::client::client() .".pm !");
	MC::ge_print("${MC::clr_red}Arguments: ge_enable GROUPNAME");
	MC::ge_print("${MC::clr_red}  GROUPNAME - triggers group to enable");
}

sub ge_disable {
	MC::ge_print("${MC::clr_b_red}You must override function 'ge_disable' with ./ge/client/". ge::client::client() .".pm !");
	MC::ge_print("${MC::clr_red}Arguments: ge_disable GROUPNAME");
	MC::ge_print("${MC::clr_red}  GROUPNAME - triggers group to disable");
}

sub ge_send {
	MC::ge_print("${MC::clr_b_red}You must override function 'ge_send' with ./ge/client/". ge::client::client() .".pm !");
	MC::ge_print("${MC::clr_red}Arguments: ge_send STRING");
	MC::ge_print("${MC::clr_red}  STRING - string to send to MUD");
}

1;
