###################################################
#
# $Id$
#
# GE - game environment
# settings for MUD-clients JMC & mmc
#
#   (c) Andrew I. Baznikin (dikiy@mud.ru) 2001, 2002
#   
###################################################

package ge::conf;

require Exporter;

@ISA=qw(Exporter);
@EXPORT=qw(load_conf, load_mud_conf, init, conf);

my %Conf;

=item load_conf()

This function load configuration information and return hash of configuration
parameters
=cut

sub load_conf {
	my %Conf;
	my $file = "./ge.conf";

	open (F, "<$file");
	while (<F>) {
		next if /(^[#;]+)|(^\s*$)/;
		/^\s*(\w+)\s*=\s*(.*)/;
		$Conf{$1}=$2;
	}
	MC::ge_print ("Loading GE config... OK") if $Conf{debug};
	if ($Conf{debug}>=3) {
		foreach $e (keys %Conf) {  MC::ge_print ("   \"$e\" => \"$Conf{$e}\""); }
	}
	return %Conf;
}

sub load_mud_conf {
	my $file = shift;

	MC::ge_print ("Loading MUD config from $Conf{dat_prefix}/$file...") if $Conf{debug};
	open (F, "<./$Conf{dat_prefix}/$file");
	while (<F>) {
		next if /(^[#;]+)|(^\s*$)/;
		/^\s*(\w+)\s*=\s*(.*)/;
		$Conf{$1}=$2;
		MC::ge_print ("   \"$1\" => \"$2\"") if $Conf{debug}>=3;
	}
}

sub conf {
	my $key = shift || return;
	return $Conf{$key};
}

sub init {
	%Conf = load_conf();
}

BEGIN {}

1;