###################################################
#
# $Id$
#
# GE - game environment
# settings for MUD-clients JMC & mmc
#
#   (c) Andrew I. Baznikin (dikiy@mud.ru) 2001, 2002
#   
###################################################

package ge::GodBot;

require Exporter;

use locale;
#use strict;

@ISA=qw(Exporter);
@EXPORT=qw(load_conf);

sub load_abuse {
	my $file = shift || "abuselist.txt";

	P::echo ("Loading abuse list from $P::Conf{dat_prefix}/$file...") if $P::Conf{debug}>=1;
	open (F, "<./$P::Conf{dat_prefix}/$file");
	while (<F>) {
		s/^\s*//;
		s/\s*$//;
		push @P::abuse_list, ($_);
	}
	my $lst = join ' ', @P::abuse_list;
	P::echo "  abuse list: $lst" if $P::Conf{debug}>=3;
}

sub check_f_abuse {
	my $str = shift;

	foreach $k (@P::abuse_list) {
		my $t = uc $k;
		P::echo "->t:'$t' k:'$k' str:'$str' uc(str):'".uc($str)."'";
		if (uc($str) =~ /$t/i) {
			return $k;
		}
	}
	return 0;
}

P::trig {
	my $who = $1;
	my $shout = $2.$3;
	my $what = $4;
	
	if ( $ret = check_f_abuse($what) ) {
		P::msg "ABUSE: $who $shout '$what' (  '$ret')";
		$punish = "mute $who 12";
		P::sendl ($punish);
		P::sendl ("tell $who     [ . : $U::my_name]");
		P::sendl (" $who -  12       ($U::my_name)");
		($m,$y) = (localtime)[4,5]; $m++; $y += 1900;
		$now = sprintf("%02u-%02u", $y, $m);
		mkdir "./logs", 770;
		mkdir "./logs/GodBot/", 770;
		open F , ">>./logs/GodBot/abuse-$now.log";
		print F localtime().": $who $shout '$what'  - : '$punish'\n";
		close F;
	}
} "(\w+) (|)(||)? : '(.*)'", "f1200:godbot";

1
